<?php

namespace spec\Dedi\SyliusContactPlugin\Twig;

use Dedi\SyliusContactPlugin\Twig\SyliusVersionTesterExtension;
use PhpSpec\ObjectBehavior;

class SyliusVersionTesterExtensionSpec extends ObjectBehavior
{
    function let() {
        $this->beConstructedWith(
            '1.7.6'
        );
    }

    function it_is_initializable()
    {
        $this->shouldHaveType(SyliusVersionTesterExtension::class);
    }

    function it_validates_same_version()
    {
        $this->testVersion([1,7,6])->shouldReturn(true);
    }

    function it_validates_previous_patch_version()
    {
        $this->testVersion([1,7,0])->shouldReturn(true);
    }

    function it_validates_previous_minor_version()
    {
        $this->testVersion([1,6,5])->shouldReturn(true);
    }

    function it_validates_previous_major_version()
    {
        $this->testVersion([0,6,5])->shouldReturn(true);
    }

    function it_does_not_validate_new_patch_version()
    {
        $this->testVersion([1,7,9])->shouldReturn(false);
    }

    function it_does_not_validate_new_minor_version()
    {
        $this->testVersion([1,9,5])->shouldReturn(false);
    }

    function it_does_not_validate_new_major_version()
    {
        $this->testVersion([2,6,5])->shouldReturn(false);
    }
}
